#include <iostream>
#include <ctype.h>

using namespace std;

const string alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
const int N = alphabet.length();

string encode(string source, int key)
{
    int len = source.length();
    string result = source;
    for(int j=0;j<len;j++)
    {
        char c = toupper(source[j]);
        int pos = alphabet.find(c);
        if(pos!=string::npos)
        {
            result[j]= alphabet[(pos+key)%N];
        }
    }
    return result;
}
string decode(string source, int key)
{
    int len = source.length();
    string result = source;
    for(int j=0;j<len;j++)
    {
        int pos = alphabet.find(source[j]);
        if(pos!=string::npos)
        {
            result[j]= alphabet[(pos-key+N)%N];
        }
    }
    return result;
}
int main()
{
    cout << "Enter key: ";
    int key;
    cin>>key;
    string publicText = "The quick brown fox jumps over the lazy dog";
    cout<<publicText<<endl;
    string encoded = encode(publicText,key);
    cout<<encoded<<endl;
    for(key=1;key<N;key++)
    {
        string decoded = decode(encoded,key);
        cout<<key<<"\t"<<decoded<<endl;
    }
    return 0;
}
